#----------------------------------------------------#
# This script runs every game tick.
# All the map specific commands are called from here.
#
# Scripter: Liontack
# Called by tag: #main:tick
#----------------------------------------------------#



### Increase tick count by 1 and go from 0 to 30
scoreboard players add tick_counter clock_tick 1
execute if score tick_counter clock_tick matches 30.. run scoreboard players set tick_counter clock_tick 0



### Keep everyone's fruit at 0 or 8
execute as @p store result score @s fruit run clear @s chorus_fruit 0
execute as @p[scores = {fruit = 1..7}] run give @s chorus_fruit 1
execute as @p[scores = {fruit = 9..}] run clear @s chorus_fruit 1

### Replace minecarts with placeable ones
execute as @p store result score @s cart run clear @s minecart 0
execute as @p store result score @s cart_place run clear @s minecart{CanPlaceOn:["activator_rail"]} 0

execute as @p if score @s cart > @s cart_place run tag @s add switch_cart
execute as @p[tag = switch_cart] run clear @s minecart
execute as @p[tag = switch_cart] run give @s minecart{CanPlaceOn:["activator_rail"]} 1
execute as @p[tag = switch_cart] run tag @s remove switch_cart



### Room mechanics
function main:small_rooms
function main:big_room



### Keep track of time spent
execute as @p[x = 23.5, dx = 502, y = 10, dy = 20, z = -2, dz = 30, tag =! finished] run scoreboard players add @s timer 1
execute as @p[x = 526, dx = 2, y = 10, dy = 2, z = -2, dz = 30, tag =! finished] run tellraw @a [{"text":"","color":"yellow","extra":[{"selector":"@s"}]}, {"text": " finished the map in ", "color":"white"}, {"score":{"name":"@s", "objective":"timer"}, "color":"green"}, {"text": " ticks!", "color":"white"}]
execute as @p[x = 526, dx = 2, y = 10, dy = 2, z = -2, dz = 30, tag =! finished] run tag @s add finished



### Set the 'thanks for playing' sign and player head
execute as @p[x = 449, y = 11, z = 11, dx = 2, dy = 2, dz = 2] unless score player_credit clock_tick matches 1.. run scoreboard players set player_credit clock_tick 1

execute if score player_credit clock_tick matches 1 run data modify block 533 12 16 Text3 set value '{"text":"","extra":[{"selector":"@p"}]}'
execute if score player_credit clock_tick matches 1 as @p[sort = nearest, limit = 1] run loot spawn 532 9 16 loot playerheadtricks:uuidtest
execute if score player_credit clock_tick matches 2 run data modify entity 24ef9bf5-f2ac-4dd2-a8c3-f1923e393cf9 ArmorItems[3] set from block 532 8 16 Items[0]

execute if score player_credit clock_tick matches 2 run scoreboard players set player_credit clock_tick 99
execute if score player_credit clock_tick matches 1 run scoreboard players set player_credit clock_tick 2
